#pragma once

#include <vector>
#include <map>
#include <string>
#include <exception>
#include <iostream>
#include "items.h"
#include "logic.h"
#include <json/json.h>

using namespace std;

#define Eo(x) { cerr << #x << " = " << (x) << endl; }

class parseException : public exception {
	string text;
	virtual const char* what() const throw();

	public:
	parseException(string);
	virtual ~parseException() throw();
};

class ALU {
	public:
		ALU(char*);
		ALU(const ALU&);
		~ALU();

		void calc();

	private:
		void dfs(int);

		vector<InputItem*> in;
		vector<Item*> out, logic;
		map<string, Item*> all;
};
